/**
 * SiteEditor Posts JS Plugin
 *
 * Copyright, 2016
 * Released under LGPL License.
 *
 * License: http://www.siteeditor.org/license
 * Contributing: http://www.siteeditor.org/contributing
 */

/*global siteEditor:true */
(function( exports, $ ){

    var api = sedApp.editor;

    api.SiteEditorPosts = api.Class.extend({
        /*
         @pageType : post || term ( || general || authors || post_type )
         */
        initialize: function ( options ) {

            var self = this;

            this.data = {
                postTypes: {},
                l10n: {
                    sectionCustomizeActionTpl: '',
                    fieldTitleLabel: '',
                    fieldContentLabel: '',
                    fieldExcerptLabel: ''
                },
                postIdInput: null
            }

            $.extend( this, options || {} );

            api.previewer.bind( 'syncPostsData', function( data ){ 
                self.receivePreviewData( data );
            });

        } ,

        receivePreviewData : function ( data ) {

            var setting;

            //console.log( "--------data.settings---------" , data.settings );

            var dataSettings = api.applyFilters( "postOptionsDataSettings" , data.settings , data.currentPostType  );

            _.each( dataSettings , function( settingArgs, id ) { 

                if ( ! api.has( id ) ) {
                    setting = api.create( id, id, settingArgs.value, {
                        transport   : settingArgs.transport || "refresh",
                        previewer   : api.previewer,
                        stype       : "general" ,
                        dirty       : settingArgs.dirty
                    } );

                    api.settings.settings[id] = settingArgs;

                    if ( settingArgs.dirty ) {
                        setting.callbacks.fireWith( setting, [ setting.get(), {} ] );
                    }

                }

            } );

            //console.log( "--------api.settings.settings---------" , api.settings.settings );

        }

    });

    $( function() {

        var postsData = window._sedAppPostsDataExports;

        api.posts = api.sedPosts = new api.SiteEditorPosts({
            data : postsData || {}
        });

    });

})( sedApp, jQuery );