/**
 * SiteEditor Posts JS Plugin
 *
 * Copyright, 2016
 * Released under LGPL License.
 *
 * License: http://www.siteeditor.org/license
 * Contributing: http://www.siteeditor.org/contributing
 */

/*global siteEditor:true */
(function( exports, $ ){

    var api = sedApp.editor;

    api.SedPageGeneralOptions = api.Class.extend({
        /*
         @pageType : post || term ( || general || authors || post_type )
         */
        initialize: function ( options ) {

            var self = this;

            $.extend( this, options || {} );

            api.previewer.bind( 'syncGeneralOptionsData', function( data ){//ready
                self.addSettings( data );
            });

        } ,

        addSettings : function ( data ) {

            if( api.settings.page.type == "post" )
                return ;

            var setting;

            var dataSettings = api.applyFilters( "GeneralOptionsDataSettings" , data.settings  );

            _.each( dataSettings , function( settingArgs, id ) {

                //var settingId = "sed_" + api.settings.page.id + "_settings[" + id + "]";

                if ( ! api.has( id ) ) {
                    setting = api.create( id , id , settingArgs.value, {
                        transport   : settingArgs.transport || "refresh",
                        previewer   : api.previewer,
                        stype       : "general"
                        //dirty: settingArgs.dirty
                    } );

                    api.settings.settings[id] = settingArgs;

                    /*if ( settingArgs.dirty ) {
                     setting.callbacks.fireWith( setting, [ setting.get(), {} ] );
                     }*/

                }

            });

        }

    });

    $( function() {

        api.pagesGeneralOptions = new api.SedPageGeneralOptions({});

    });

})( sedApp, jQuery );